Index: trunk/src/VBox/Additions/WINNT/Installer/ISO/AUTORUN.INF
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/ISO/AUTORUN.INF	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/ISO/AUTORUN.INF	(revision 31661)
@@ -2,6 +2,11 @@
 ; Copyright (C) 2006-2010 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Loader/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Loader/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/Loader/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2008 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.cpp	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.cpp	(revision 31661)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/Loader/VBoxWindowsAdditions.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2008 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Loader/resource.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Loader/resource.h	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/Loader/resource.h	(revision 31661)
@@ -7,6 +7,11 @@
  * Copyright (C) 2008 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.cpp	(revision 31661)
@@ -5,6 +5,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/RegCleanup.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.def
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.def	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.def	(revision 31661)
@@ -3,6 +3,11 @@
 ; Copyright (C) 2006-2007 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBCoInst.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxDrvInst.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxDrvInst.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxDrvInst.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.cpp	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.cpp	(revision 31661)
@@ -5,6 +5,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestDrvInst.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.def
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.def	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.def	(revision 31661)
@@ -2,6 +2,11 @@
 ; Copyright (C) 2006-2007 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/dll/vboxmrxp.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/Makefile.kmk	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/Makefile.kmk	(revision 31661)
@@ -7,6 +7,11 @@
 # Copyright (C) 2006-2007 Oracle Corporation
 #
-# Oracle Corporation confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 #
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.inf
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.inf	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.inf	(revision 31661)
@@ -4,6 +4,11 @@
 ; Copyright (C) 2006-2007 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.rc	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/VBoxSF.rc	(revision 31661)
@@ -2,6 +2,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss.asm
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss.asm	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss.asm	(revision 31661)
@@ -4,6 +4,11 @@
 ; Copyright (C) 2006-2007 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss/rdbss.def
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss/rdbss.def	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/rdbss/rdbss.def	(revision 31661)
@@ -4,6 +4,11 @@
 ; Copyright (C) 2006-2007 Oracle Corporation
 ;
-; Oracle Corporation confidential
-; All rights reserved
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 ;
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhdrs.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhdrs.h	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhdrs.h	(revision 31661)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.c	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.c	(revision 31661)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.h	(revision 31634)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/redirector/sys/vbsfhlp.h	(revision 31661)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 