Index: /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 31751)
+++ /trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest.cpp	(revision 31752)
@@ -1181,10 +1181,10 @@
                                           VBoxGuestWaitEventInfo *pInfo,  size_t *pcbDataReturned, bool fInterruptible)
 {
-    const uint32_t fReqEvents = pInfo->u32EventMaskIn;
-    uint32_t fResEvents;
-    int iEvent;
-    int rc;
-    RTSPINLOCKTMP Tmp = RTSPINLOCKTMP_INITIALIZER;
-    PVBOXGUESTWAIT pWait;
+    RTSPINLOCKTMP   Tmp = RTSPINLOCKTMP_INITIALIZER;
+    const uint32_t  fReqEvents = pInfo->u32EventMaskIn;
+    uint32_t        fResEvents;
+    int             iEvent;
+    PVBOXGUESTWAIT  pWait;
+    int             rc;
 
     pInfo->u32EventFlagsOut = 0;
@@ -1364,4 +1364,7 @@
                                            VMMDevRequestHeader *pReqHdr, size_t cbData, size_t *pcbDataReturned)
 {
+    int                     rc;
+    VMMDevRequestHeader    *pReqCopy;
+
     /*
      * Validate the header and request size.
@@ -1370,6 +1373,4 @@
     const uint32_t          cbReq     = pReqHdr->size;
     const uint32_t          cbMinSize = vmmdevGetRequestSize(enmType);
-    int rc;
-    VMMDevRequestHeader *pReqCopy;
 
     Log(("VBoxGuestCommonIOCtl: VMMREQUEST type %d\n", pReqHdr->requestType));
@@ -1609,5 +1610,5 @@
             if (i >= RT_ELEMENTS(pSession->aHGCMClientIds))
             {
-                static unsigned s_cErrors = 0;
+                static unsigned             s_cErrors = 0;
                 VBoxGuestHGCMDisconnectInfo Info;
 
@@ -1634,9 +1635,8 @@
      * Validate the client id and invalidate its entry while we're in the call.
      */
-    const uint32_t u32ClientId = pInfo->u32ClientID;
-    unsigned i;
-    RTSPINLOCKTMP Tmp = RTSPINLOCKTMP_INITIALIZER;
-    int rc;
-
+    int             rc;
+    const uint32_t  u32ClientId = pInfo->u32ClientID;
+    unsigned        i;
+    RTSPINLOCKTMP   Tmp = RTSPINLOCKTMP_INITIALIZER;
     RTSpinlockAcquireNoInts(pDevExt->SessionSpinlock, &Tmp);
     for (i = 0; i < RT_ELEMENTS(pSession->aHGCMClientIds); i++)
@@ -1685,10 +1685,10 @@
                                          size_t cbExtra, size_t cbData, size_t *pcbDataReturned)
 {
-    size_t cbActual;
-    const uint32_t u32ClientId = pInfo->u32ClientID;
-    unsigned i;
-    int rc;
-    RTSPINLOCKTMP Tmp = RTSPINLOCKTMP_INITIALIZER;
-    uint32_t fFlags;
+    const uint32_t  u32ClientId = pInfo->u32ClientID;
+    RTSPINLOCKTMP   Tmp = RTSPINLOCKTMP_INITIALIZER;
+    uint32_t        fFlags;
+    size_t          cbActual;
+    unsigned        i;
+    int             rc;
 
     /*
@@ -1784,6 +1784,6 @@
 static int VBoxGuestCommonIOCtl_HGCMClipboardReConnect(PVBOXGUESTDEVEXT pDevExt, uint32_t *pu32ClientId, size_t *pcbDataReturned)
 {
-    int rc;
-    VBoxGuestHGCMConnectInfo Info;
+    int                         rc;
+    VBoxGuestHGCMConnectInfo    CnInfo;
 
     Log(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: Current u32ClientId=%RX32\n", pDevExt->u32ClipboardClientId));
@@ -1794,8 +1794,8 @@
     if (pDevExt->u32ClipboardClientId != 0)
     {
-        VBoxGuestHGCMDisconnectInfo Info;
-        Info.result = VERR_WRONG_ORDER;
-        Info.u32ClientID = pDevExt->u32ClipboardClientId;
-        rc = VbglR0HGCMInternalDisconnect(&Info, VBoxGuestHGCMAsyncWaitCallback, pDevExt, RT_INDEFINITE_WAIT);
+        VBoxGuestHGCMDisconnectInfo DiInfo;
+        DiInfo.result = VERR_WRONG_ORDER;
+        DiInfo.u32ClientID = pDevExt->u32ClipboardClientId;
+        rc = VbglR0HGCMInternalDisconnect(&DiInfo, VBoxGuestHGCMAsyncWaitCallback, pDevExt, RT_INDEFINITE_WAIT);
         if (RT_SUCCESS(rc))
         {
@@ -1803,8 +1803,8 @@
             return rc;
         }
-        if (RT_FAILURE((int32_t)Info.result))
-        {
-            Log(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: failed to disconnect old client. Info.result=%Rrc\n", rc));
-            return Info.result;
+        if (RT_FAILURE((int32_t)DiInfo.result))
+        {
+            Log(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: failed to disconnect old client. DiInfo.result=%Rrc\n", DiInfo.result));
+            return DiInfo.result;
         }
         pDevExt->u32ClipboardClientId = 0;
@@ -1814,10 +1814,10 @@
      * Try connect.
      */
-    Info.Loc.type = VMMDevHGCMLoc_LocalHost_Existing;
-    strcpy(Info.Loc.u.host.achName, "VBoxSharedClipboard");
-    Info.u32ClientID = 0;
-    Info.result = VERR_WRONG_ORDER;
-
-    rc = VbglR0HGCMInternalConnect(&Info, VBoxGuestHGCMAsyncWaitCallback, pDevExt, RT_INDEFINITE_WAIT);
+    CnInfo.Loc.type = VMMDevHGCMLoc_LocalHost_Existing;
+    strcpy(CnInfo.Loc.u.host.achName, "VBoxSharedClipboard");
+    CnInfo.u32ClientID = 0;
+    CnInfo.result = VERR_WRONG_ORDER;
+
+    rc = VbglR0HGCMInternalConnect(&CnInfo, VBoxGuestHGCMAsyncWaitCallback, pDevExt, RT_INDEFINITE_WAIT);
     if (RT_FAILURE(rc))
     {
@@ -1825,5 +1825,5 @@
         return rc;
     }
-    if (RT_FAILURE(Info.result))
+    if (RT_FAILURE(CnInfo.result))
     {
         LogRel(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: VbglHGCMConnected -> rc=%Rrc\n", rc));
@@ -1831,8 +1831,8 @@
     }
 
-    Log(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: connected successfully u32ClientId=%RX32\n", Info.u32ClientID));
-
-    pDevExt->u32ClipboardClientId = Info.u32ClientID;
-    *pu32ClientId = Info.u32ClientID;
+    Log(("VBoxGuestCommonIOCtl: CLIPBOARD_CONNECT: connected successfully u32ClientId=%RX32\n", CnInfo.u32ClientID));
+
+    pDevExt->u32ClipboardClientId = CnInfo.u32ClientID;
+    *pu32ClientId = CnInfo.u32ClientID;
     if (pcbDataReturned)
         *pcbDataReturned = sizeof(uint32_t);
@@ -2003,5 +2003,4 @@
 {
     int rc;
-
     Log(("VBoxGuestCommonIOCtl: iFunction=%#x pDevExt=%p pSession=%p pvData=%p cbData=%zu\n",
          iFunction, pDevExt, pSession, pvData, cbData));